# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys
import ctypes

user32DLL = ctypes.windll.user32


class info(object):
    def __init__(self):
        pass
    

class Position(ctypes.Structure):
    _fields_ = [
        ("x", ctypes.c_ulong),
        ("y", ctypes.c_ulong)
        ]

def getMousePos():
    pos = Position()    
    user32DLL.GetCursorPos(ctypes.byref(pos))
    return int(pos.x), int(pos.y)

def setMousePos(x,y):
    user32DLL.SetCursorPos(x,y)
    



class pscript(Ly.Mclass):

    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False
        

    def Create(self):
        self.ChannelRelation = Ly.CR_1_2
        return True


    def DlgInit(self, dlg):
        self.DlgNumChannels = 1
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = 1

        dm = lys.DialogManager(self, dlg)

        dm.SelectModulePage()
        dm.AppendCategory("Modul-Einstellungen: keine!", "")

        dm.SelectChannelPage()
        dm.AppendCategory("Modul-Einstellungen: keine!", "")
    #end DlgInit       
                  

    def DlgOk(self, dlg):
        self.DlgNumChannels = 1
        self.SetConnectors(1,2)
    #end DlgOk
        

    def DlgCancel(self, dlg):
        pass

        
    def Save(self):
        pass


    def Load(self):
        pass


    def SetupFifo(self, channel):
        self.SetSampleDistance(channel, self.GetSampleDistance(channel)*self.GetMaxBlockSize(channel))
        self.SetMaxBlockSize(channel, 1)


    def Start(self):        
        self.MeasurementRunning = True
        self.screensize = user32DLL.GetSystemMetrics(0), user32DLL.GetSystemMetrics(1)
        print "Bildschirm-Auflsung: ", self.screensize
        self.x_soll_pos = 0                             # Mauszeiger zu Anfang in der 
        self.y_mitte = int(self.screensize[1]/2)        #   Mitte am linken Bildschirmrand
        Ly.SetVar(1, self.screensize[1])
    #end Start


    def Stop(self):
        self.MeasurementRunning = False
    

    # Es ist nur ein Kanal in diesem Beispiel vorhanden.
    def ProcessData(self):

        InBuff = self.GetInputBlock(0)          # Signal vom Generator
        OutBuff1 = self.GetOutputBlock(0)       # Ausgabe: X-Koordinate
        OutBuff2 = self.GetOutputBlock(1)       #          Y-Koordinate
        if InBuff is None or OutBuff1 is None or OutBuff2 is None:
            return True


        # Mauszeiger wandert von links nach rechts
        self.x_soll_pos += 1
        if self.x_soll_pos > int(self.screensize[0]):
            self.x_soll_pos = 0

        # Mauszeiger folgt dem vom Eingang gelesenen Signal
        tmp_y = int(self.y_mitte + InBuff[0])
        if tmp_y < 0:
            tmp_y = 0
        if tmp_y > self.screensize[1]:
            tmp_y = self.screensize[1]
        setMousePos(self.x_soll_pos, tmp_y)        

        aktuelle_maus_position = getMousePos()

        # OutBuffs konfigurieren,...
        OutBuff1.StartTime = InBuff.StartTime
        OutBuff1.BlockSize = 1
        OutBuff1.SampleDistance = InBuff.SampleDistance * InBuff.BlockSize
        OutBuff2.StartTime = InBuff.StartTime
        OutBuff2.BlockSize = 1
        OutBuff2.SampleDistance = InBuff.SampleDistance * InBuff.BlockSize

        # ... befllen, ...
        OutBuff1[0] = aktuelle_maus_position[0]
        OutBuff2[0] = aktuelle_maus_position[1]

        # ... und freigeben
        InBuff.Release()
        OutBuff1.Release()
        OutBuff2.Release()        
        
        return True
    #end ProcessData
#end class
            
    
