# -*- coding: iso-8859-15 -*-

import Ly, lys
import sys

abort = False

try:
    import win32com.client
    import pythoncom
except ImportError:
    print "Fehler beim Importieren von win32com und/oder pythoncom."
    abort = True

class info(object):
    def __init__(self):
        self.modul_interaktiv = False

class var(object):
    def __init__(self):
        pass
        
class pscript(Ly.Mclass):
    def __init__(self, magic):
        self.info = info()
        self.var = var()

    def Create(self):
        return True

    def DlgInit(self, dlg):
        self.DlgNumChannels = 5
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = 5

        dm = lys.DialogManager(self, dlg)

        dm.SelectModulePage()
        dm.AppendCategory("Modul-Einstellungen", "")
        dm.AppendBool("Interaktiv",
                      self.info.modul_interaktiv,
                      desc="Setzt Excel whrend der Messung auf 'interaktiv' (oder nicht)." \
                      "\nKlickt man whrend der Messung in Excel herum, kann es zu einem Fehler kommen." \
                      " Deaktivierte Interaktivitt verhindert dies." \
                      "\nnderung der Einstellung wird nur bei Messungsstart angewendet.")        
        
        dm.SelectChannelPage()
        dm.AppendCategory("Kanal-Einstellungen: keine!", "")
    #end DlgInit


    def DlgOk(self, dlg):
        self.DlgNumChannels = 5
        
        dom = lys.DialogOkManager(dlg)

        #Modul
        dom.SelectModulePage()
        self.info.modul_interaktiv = dom.GetValue("Interaktiv")
        
        #Kanle
        dom.SelectChannelPage()
        #nichts zu tun

        self.SetConnectors(5, 0)
    #end DlgOk

                            
    def DlgCancel(self, dlg):
        pass
    
    
    def Save(self):
        pass
    
    
    def Load(self):
        pass
    
    
    def SetupFifo(self, channel):
        pass
    
    
    def Start(self):
        # Falls die pyWin-Bibliotheken nicht geladen werden konnten, gar nicht erst loslegen.
        if abort:
            return False
        try:
            self.var.xlapp = win32com.client.Dispatch("Excel.Application")
        except:
            print "Fehler beim Anfordern des COM-Objekts:"
            print "self.var.xl = win32com.client.Dispatch('Excel.Application')"
            return False
        
        self.var.xlapp.Visible = 1 # 0=Excel verbergen (Alternative zum Nicht-Interaktiv setzen?)

        # Eine neue Mappe in Excel anlegen, falls aktuell keine zum Beschreiben vorhanden ist.
        if self.var.xlapp.ActiveWorkbook is None:
            self.var.xlapp.Workbooks.Add()

        # Ab Zeile 3 10 Zeilen beschreiben (danach wird wieder bei Zeile weitergemacht)
        self.var.maxzeilen = 10
        self.var.startzeile = 3
        self.var.aktuellezeile = self.var.startzeile

        # Wenn man Excel interaktiv lt, kommt es zu einem Fehler (Traceback siehe unten)
        #    beim Herumklicken in Excel whrend der Messung
        self.var.xlapp.Interactive = self.info.modul_interaktiv

        # Spalten beschriften
        for aktuellerkanal in range(self.NumInChannel):
            self.var.xlapp.Worksheets(1).Cells(1, aktuellerkanal+1).Value = "Kanal "+str(aktuellerkanal)
    #end Start
            
    
    def Stop(self):
        self.var.xlapp.Interactive = True
        

    def ProcessData(self):        
        for aktuellerkanal in range(self.NumInChannel):
            if self.GetInputBlock(aktuellerkanal) is None:
                return True
        for aktuellerkanal in range(self.NumInChannel):            
            InBuff = self.GetInputBlock(aktuellerkanal)
            spalte = aktuellerkanal+1
            zeile = self.var.aktuellezeile
            self.var.xlapp.Worksheets(1).Cells(zeile, spalte).Value = InBuff[0] #Blockgre 1
            InBuff.Release()
        self.var.aktuellezeile += 1
        if self.var.aktuellezeile >= (self.var.startzeile + self.var.maxzeilen):
            self.var.aktuellezeile = self.var.startzeile            
        return True
    #end ProcessData
#end class
            

## Wenn man Excel interaktiv lsst, bewirkt Herumgeklicke in Excel whrend
## der Messung die folgende Fehlermeldung (MS Office/Excel 2003):

##Fehler in: PScript00
##Traceback (most recent call last):
##  File "P:\!DASYLab Verzeichnisse\other\script\tmp\PScript00.py", line 96, in ProcessData
##  File "C:\Programme\Python26\lib\site-packages\win32com\client\dynamic.py", line 554, in __setattr__
##    self._oleobj_.Invoke(entry.dispid, 0, invoke_type, 0, value)
##pywintypes.com_error: (-2147352567, 'Ausnahmefehler aufgetreten.', (0, None, None, None, 0, -2146777998), None)
