# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys


class info( object ):
    def __init__( self ):
        pass # Keine Einstellmglichkeiten fr den Benutzer in diesem Beispiel verfgbar.


class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()


    # beim Laden eines Skripts ins Modul
    def Create(self):
        return True


##    def DlgPropertyControl(self, dlg, properties):
##        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft
##        for seite, prop in properties:
##            dlg.opt.SelectPage(seite)
##            dlg.opt.EnableProperty(prop, state)    


    # beim Doppelklick auf ein Modul
    def DlgInit(self, dlg):        
        # In diesem Modul ist die Kanalrelation 1:N, es gibt genau einen Eingang:
        # - Mit den Buttons der Kanalleiste ist in diesem Beispiel die Anzahl der Ausgnge whlbar.
        self.DlgNumChannels = self.NumOutChannel
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS
       
        #dlg.opt.v = [{}, {}]               #DLab12
        dim = lys.DialogManager(self, dlg)  #Dlab13
    #end DlgInit
            

    # Dialog wird mit Ok-Taste verlassen
    def DlgOk(self, dlg):
        # Anzahl der Ein- zu Ausgngen manuell festlegen:
        # Mit SetConnectors kann man nun explizit vorgeben, wieviele Eingnge und Ausgnge vorhanden sein sollen.
        # In diesem Beispiel hat man genau einen Eingang mit einer variablen Anzahl an Ausgngen.
        self.SetConnectors(1, self.DlgNumChannels)
    #end DlgOk    

        
    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.        
    def DlgCancel(self, dlg):
        pass
        

    # Schaltbild wird gespeichert.        
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe(!)-Fifos
    # - In diesem Beispiel werden die Daten des einzigen Moduleingangs auf die Ausgnge 'verteilt'.
    # - Jeder Wert wird sofort ausgegeben:
    #   - Blockgre 1
    #   - Sampledistanz ist gleich Eingangs-Sampledistanz * 'Anzahl der Ausgnge'
    def SetupFifo(self, channel):
        self.SetSampleDistance(channel, self.GetSampleDistance(channel) * self.NumOutChannel)
        self.SetMaxBlockSize(channel, 1)
        

    # Die Messung wird gestartet.        
    def Start(self):
        pass

        
    # Die Messung wird gestartet.        
    def Stop(self):
        pass
    

    # Wenn dieses Modul an der Reihe ist, i.d.R.:
    # - Daten beschaffen
    #   - Datenblcke an den Eingngen abholen (->InBuff),
    #   - aus Variablen lesen (->Ly.GetVar(Nummer)),
    #   - von Hardware/Treiber lesen (->selber machen) oder
    # - Daten verarbeiten,
    # - Daten ausgeben
    #   - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release),
    #   - in Variablen schreiben (->Ly.SetVar(Nummer, Wert))
    #   - auf Hardware/Treiber schreiben (->selber machen)
    # - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)    
    def ProcessData(self):
        
        # Liegen an Ein-/Ausgngen neue Blcke bereit?
        # - Falls nicht, ProcessData verlassen und im nchsten Aufruf erneut probieren
        if self.GetInputBlock(0) is None:                   # genau 1 Eingang
            return True
        for outkanal in range(self.NumOutChannel):          # variable Anzahl Ausgnge
            if self.GetOutputBlock(outkanal) is None:
                return True

        InBuff = self.GetInputBlock(0)

        # Die Werte des Eingangsblocks durchlaufen
        for blockpos in range(InBuff.BlockSize):            # 0..Blocksize-1
            data = InBuff[blockpos]

            # Auf welchem Ausgang soll der Wert ausgegeben werden?
            intervall_obergrenze = 0                        # erstes Intervall: [-1..0), zweites: [0..1), usw
            for i in range(self.NumOutChannel):             # 0..NumOutChannel-1
                outkanal = i
                if (data < intervall_obergrenze):           # vorzeitig Schleife verlassen,
                    break                                   #   falls Schublade gefunden
                intervall_obergrenze += 1
            #end for

            # Ausgabe vorbereiten und durchfhren:
            # - OutBuff des entsprechenden Ausgangs holen
            # - Wert in den OutBuff an erster Position schreiben (Blockgre 1!)
            # - OutBuff-Parameter berechnen/setzen
            # - OutBuff freigeben
            OutBuff = self.GetOutputBlock(outkanal)
            OutBuff[0] = data
            OutBuff.StartTime = InBuff.StartTime
            OutBuff.BlockSize = 1
            OutBuff.SampleDistance = InBuff.SampleDistance * self.NumOutChannel
            OutBuff.Release()
            #end if
        #end for blockpos

        # Der Eingangsdatenblock wurde einmal ganz durchlaufen: nun freigeben.
        InBuff.Release() 

        return True
    #end ProcessData
#end class






##            outkanal = 0
##            intervall_obergrenze = 0
##            while (True):
##                if (data < intervall_obergrenze) or (outkanal == self.NumOutChannel-1):
##                    break
##                outkanal += 1
##                intervall_obergrenze += 1
##            #end while


##                if (data < 0) : outkanal=0
##            elif (data >= 0) and (data < 1): outkanal=1
##            elif (data >= 1) and (data < 2): outkanal=2
##            elif (data >= 2) and (data < 3): outkanal=3
##            elif (data >= 3) and (data < 4): outkanal=4
##            elif (data >= 4) and (data < 5): outkanal=5
##            elif (data >= 5) and (data < 6): outkanal=6
##            elif (data >= 6) and (data < 7): outkanal=7
##            elif (data >= 7) and (data < 8): outkanal=8
##            elif (data >= 8) and (data < 9): outkanal=9
##            elif (data >= 9) and (data < 10): outkanal=10
##            elif (data >= 10) and (data < 11): outkanal=11
##            elif (data >= 11) and (data < 12): outkanal=12
##            elif (data >= 12) and (data < 13): outkanal=13
##            elif (data >= 13) and (data < 14): outkanal=14
##            elif data >= 14: outkanal=15
