# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys


class info( object ):
    def __init__( self ):
        #Modul
        self.modul_faktor = 1
        #Kanal
        self.kanal_summand = [0 for n in range(0,16)]   # Fr jeden der 16 Kanle den Wert mit 0 vorbelegen
        self.kanal_summand[1] = 1                       # Beim zweiten Kanal die Voreinstellung auf 1 ndern.
        



class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False


    # beim Laden eines Skripts ins Modul
    def Create(self):
        return True


    # Hilfsmethode: beim ffnen des Moduleigenschaftsdialogs, siehe Ende von DlgInit
    # Ausgrauen/Disablen von einstellbaren Modul/Kanal-Eigenschaften (AppendInt usw)
    def DlgPropertyControl(self, dlg, properties):
        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft
        for seite, prop in properties:
            dlg.opt.SelectPage(seite)
            dlg.opt.EnableProperty(prop, state)    


    def DlgInit(self, dlg):
        dlg.title = "1zu1 Beispiel"
        
        # Mindestens einen Kanalbutton/Stecker im Dialog
        self.DlgNumChannls = (1 if ((self.NumInChannel == 0) or (self.NumOutChannel == 0)) else self.NumInChannel)
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS

        dim = lys.DialogManager(self, dlg)

        dim.SelectModulePage()
        dim.AppendInt("Faktor", self.info.modul_faktor, "Platzhafter fr sinnvolle Attribut-Beschreibung")

        dim.SelectChannelPage()
        dim.AppendInt("Summand", self.info.kanal_summand, "Platzhafter fr sinnvolle Attribut-Beschreibung")
       
        # Festlegen, welche Meneintrge whrend der Messung deaktiviert werden sollen,
        # sodass sie vom Benutzer nicht mehr verstellt werden knnen.
        # Parameter: 'Dialogseite' auf der der 'Property name' zu finden ist.
        # Der 'Faktor' soll whrend der Messung nicht angepasst werden knnen.
        # Die 'Summanden' knnen angepasst werden whrend der Messung.
        DlgDeactivatableProperties = []
        DlgDeactivatableProperties.append((0,"Faktor"))
        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
    #end DlgInit13
            


    # Dialog wird mit Ok-Taste verlassen
    # - Im Dialog vernderte Werte mssen nun noch ins info-Objekt gespeichert werden,
    #   damit DASYLab sie auch fr die Messung verwendet. Bisher stehen die Werte nur
    #   "im" Dialog.
    def DlgOk(self, dlg):
        dom = lys.DialogOkManager(dlg)
        
        dom.SelectModulePage()
        self.info.modul_faktor = dom.GetValue("Faktor")
        
        dom.SelectChannelPage()
        self.info.kanal_summand = dom.GetValue("Summand")

        self.SetConnectors(self.DlgNumChannels, self.DlgNumChannels) 
    #end DlgOk        
            

    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.        
    def DlgCancel(self, dlg):
        pass
        

    # Schaltbild wird gespeichert.        
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe-FIFOs        
    def SetupFifo(self, channel):
        pass


    # Die Messung wird gestartet.        
    def Start(self):
        self.MeasurementRunning = True


    # Die Messung wird gestartet.        
    def Stop(self):
        self.MeasurementRunning = False
    

    # Wenn dieses Modul an der Reihe ist, i.d.R.:
    # - Daten beschaffen
    #   - Datenblcke an den Eingngen abholen (->InBuff),
    #   - aus Variablen lesen (->Ly.GetVar(Nummer)),
    #   - von Hardware/Treiber lesen (->selber machen) oder
    # - Daten verarbeiten,
    # - Daten ausgeben
    #   - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release),
    #   - in Variablen schreiben (->Ly.SetVar(Nummer, Wert))
    #   - auf Hardware/Treiber schreiben (->selber machen)
    # - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)    
    def ProcessData(self):
        
        # Liegen an allen Eingngen Daten vor?
        for aktuellerkanal in range(self.NumInChannel):
            if self.GetInputBlock(aktuellerkanal) is None:
                return True
        
        # Das vorgelagerte Modul hat seine(n) OutBuff(s) freigegeben und
        # an allen Eingngen dieses Moduls liegen Daten zur Verarbeitung bereit.
        for aktuellerkanal in range(self.NumInChannel):
            
            InBuff = self.GetInputBlock(aktuellerkanal)     # InBuff hat die Daten des aktuellen Kanals
            OutBuff = self.GetOutputBlock(aktuellerkanal)   # OutBuff: Ausgabe-Puffer des aktuellen Kanals

            # Daten vom info-Objekt holen,
            # die Eingabedaten verarbeiten und in den Ausgabepuffer schreiben            
            faktor = self.info.modul_faktor                     # Modulvariable
            summand = self.info.kanal_summand[aktuellerkanal]   # Kanalvariable
            for blockpos in range(InBuff.BlockSize):        # range: [0..blocksize-1]
                OutBuff[blockpos] = InBuff[blockpos] * faktor + summand

            # Parameter des Ausgabepuffer festlegen
            OutBuff.StartTime = InBuff.StartTime
            OutBuff.BlockSize = InBuff.BlockSize
            OutBuff.SampleDistance = InBuff.SampleDistance
            
            InBuff.Release()
            OutBuff.Release()
        return True
#end class
            
    
