# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys


RECHENART_TEXTE = ["Addieren", "Subtrahieren", "Multiplizieren", "Dividieren"]



class info( object ):
    def __init__( self ):
        # Modul
        # - In diesem Modul nicht verwendet.
        # Kanal
        # - Fr jeden der 16 Kanle den Wert vorbelegen.
        # - Fr den zweiten Kanal die Voreinstellung ndern.
        self.kanal_rechenart = [RECHENART_TEXTE[0] for n in range(0, Ly.MAX_CHANNELS/2)] # 8
        self.kanal_rechenart[1] = RECHENART_TEXTE[1]
    #end init
#end class




class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False                 # gibt's Ly.isRunning() ?


    # beim Laden eines Skripts ins Modul
    def Create(self):
        return True


    def DlgPropertyControl(self, dlg, properties):
        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft
        for seite, prop in properties:
            dlg.opt.SelectPage(seite)
            dlg.opt.EnableProperty(prop, state)
    #end DlgPropertyControl


    # beim Doppelklick auf ein Modul
    def DlgInit(self, dlg):        
        # In diesem Modul ist die Kanalrelation 2:1:
        # - Mit den Buttons der Kanalleiste ist  die Anzahl der Ausgabekanle whlbar.
        # - Zwei Eingangswerte ergeben verrechnet (+ - * /) einen Ausgabewert.
        self.DlgNumChannels = self.NumOutChannel
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS/2

        dim = lys.DialogManager(self, dlg)

        #Modul-Einstellungen
        dim.SelectModulePage()

        #Kanal-Einstellungen
        dim.SelectChannelPage()

        dim.AppendEnum("Rechenart",
                       #"Addieren\nSubtrahieren\nMultiplizieren\nDividieren\n", # mit/ohne \n am Ende?!
                       "".join([text+"\n" for text in RECHENART_TEXTE]),
                       self.info.kanal_rechenart,  # Kanaleinstellungen -> eine Liste!
                       "Platzhalter fr eine sinnvolle Beschreibung")

        DlgDeactivatableProperties = []
        DlgDeactivatableProperties.append((1,"Rechenart"))
        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
    #end DlgInit


    def DlgOk(self, dlg):
        dom = lys.DialogOkManager(dlg)
        
        dom.SelectModulePage()
        # keine
        
        dom.SelectChannelPage()
        self.info.kanal_rechenart = dom.GetValue("Rechenart")

        self.SetConnectors(self.DlgNumChannels*2, self.DlgNumChannels)  # Kanalrelation 2:1

    #end DlgOk
            

    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.        
    def DlgCancel(self, dlg):
        pass
        

    # Schaltbild wird gespeichert.        
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe-FIFOs        
    def SetupFifo(self, channel):
        self.SetSampleDistance(channel, self.GetSampleDistance(channel))
        self.SetMaxBlockSize(channel, self.GetMaxBlockSize(channel))
        

    # Die Messung wird gestartet.        
    def Start(self):
        self.MeasurementRunning = True

        
    # Die Messung wird gestartet.        
    def Stop(self):
        self.MeasurementRunning = False
    

    # Wenn dieses Modul an der Reihe ist, i.d.R.:
    # - Daten beschaffen
    #   - Datenblcke an den Eingngen abholen (->InBuff),
    #   - aus Variablen lesen (->Ly.GetVar(Nummer)),
    #   - von Hardware/Treiber lesen (->selber machen) oder
    # - Daten verarbeiten,
    # - Daten ausgeben
    #   - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release),
    #   - in Variablen schreiben (->Ly.SetVar(Nummer, Wert))
    #   - auf Hardware/Treiber schreiben (->selber machen)
    # - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)    
    def ProcessData(self):
        
        # Liegen an allen Eingngen Daten vor?
        # - Falls nicht, ProcessData verlassen und im nchsten Aufruf erneut probieren
        for inkanal in range(self.NumInChannel):
            if self.GetInputBlock(inkanal) is None:
                return True        
        # Das vorgelagerte Modul hat seine(n) OutBuff(s) freigegeben und
        # an allen Eingngen dieses Moduls liegen Daten zur Verarbeitung bereit.

        # Jeder Kanal wird nun separat behandelt.
        # Zu jedem Kanal gehrt ein Ausgang und zwei Eingnge.
        # Eingang:   Ausgang:
        #        0          0      Ausgangsnummer n --> Eingangsnummer (n*2)   und
        #        1                                  --> Eingangsnummer (n*2+1)
        #        2          1
        #        3
        #        4          2
        #        5
        # ...
        for ausgangsnummer in range(self.NumOutChannel):

            OutBuff = self.GetOutputBlock(ausgangsnummer)           # OutBuff_ausgangsnummer            
            InBuff_1 = self.GetInputBlock(ausgangsnummer * 2)       # InBuff_ausgangsnummer_mal_2
            InBuff_2 = self.GetInputBlock(ausgangsnummer * 2 + 1)   # InBuff_ausgangsnummer_mal_2_plus_1

            # Durch die einzelnen Werte eines Datenblocks laufen
            # zum Beispiel:     1. Wert von InBuff_1
            #                 + 1. Wert von InBuff_2
            #                 = 1. Wert von OutBuff        usw.
            for blockpos in range(InBuff_1.BlockSize):
                if self.info.kanal_rechenart[ausgangsnummer] == "Addieren": # RECHENART_TEXTE[0]
                    data = InBuff_1[blockpos] + InBuff_2[blockpos]
                elif self.info.kanal_rechenart[ausgangsnummer] == "Subtrahieren":
                    data = InBuff_1[blockpos] - InBuff_2[blockpos]
                elif self.info.kanal_rechenart[ausgangsnummer] == "Multiplizieren":
                    data = InBuff_1[blockpos] * InBuff_2[blockpos]
                elif self.info.kanal_rechenart[ausgangsnummer] == "Dividieren":
                    try:
                        data = InBuff_1[blockpos] / InBuff_2[blockpos]
                    except ZeroDivisionError:
                        print "Fehler: Division durch Null in Kanal "+str(ausgangsnummer)
                        data = 0 # in DASYLab vmtl 'maxFloat'
                #end if
                OutBuff[blockpos] = data
            #end for

            # Parameter des Ausgabepuffer festlegen
            OutBuff.StartTime = InBuff_1.StartTime
            OutBuff.BlockSize = InBuff_1.BlockSize
            OutBuff.SampleDistance = InBuff_1.SampleDistance
            
            InBuff_1.Release()
            InBuff_2.Release()            
            OutBuff.Release()
        #end for
        return True
    #end ProcessData
#end class

# DLAB_FLOAT_MAX
