# -*- coding: cp1252 -*-

import Ly
import lys
import sys

AUSGAENGE_PRO_EINGANG = 3 #3 default


class info( object ):
    def __init__( self ):
        pass # Keine Einstellmglichkeiten fr den Benutzer in diesem Beispiel verfgbar.


class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()


    # beim Laden eines Skripts ins Modul
    def Create(self):
        self.ChannelRelation = Ly.CR_ALL_ALL # entspricht Relation M:N
        return True


    # beim Doppelklick auf ein Modul
    def DlgInit(self, dlg):        
        # In diesem Modul ist die Kanalrelation M:N - pro Eingang soll es N Ausgnge geben:
        # - Mit den Buttons der Kanalleiste ist in diesem Beispiel die Anzahl der Eingnge whlbar.
        self.DlgNumChannels = self.NumInChannel
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS / AUSGAENGE_PRO_EINGANG #3

        # In diesem Beispiel gibt es keine whlbaren Einstellungsmglichkeiten.
        #dlg.opt.v = [{}, {}]                   # DASYLab 12
        #dim = lys.DialogManager(self, dlg)     # DASYLab 13, kann auch ganz weggelassen werden
    #end DlgInit
            

    # Dialog wird mit Ok-Taste verlassen
    def DlgOk(self, dlg):
        # Anzahl der Ein- zu Ausgngen manuell festlegen:
        # In diesem Modul ist die Kanalrelation M:N - pro Eingang soll es N Ausgnge geben:
        # Mit SetConnectors kann man nun separat vorgeben, wieviele Eingnge und Ausgnge man berhaupt hat.
        # - Die im Dialog einstellbare Anzahl an Kanlen sind die Eingnge.
        # - Anzahl der Ausgnge * 'Kanalrelation' = Anzahl Eingnge
        self.SetConnectors(self.DlgNumChannels, self.DlgNumChannels * AUSGAENGE_PRO_EINGANG)
    #end DlgOk

        
    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.        
    def DlgCancel(self, dlg):
        pass
        

    # Schaltbild wird gespeichert.        
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        self.ChannelRelation = Ly.CR_ALL_ALL # entspricht Relation M:N


    # Konfiguration der Ausgabe-FIFOs
    def SetupFifo(self, channel):
        pass
        

    # Die Messung wird gestartet.        
    def Start(self):
        pass

        
    # Die Messung wird gestartet.        
    def Stop(self):
        pass
    

    # Wenn dieses Modul an der Reihe ist, i.d.R.:
    # - Daten beschaffen
    #   - Datenblcke an den Eingngen abholen (->InBuff),
    #   - aus Variablen lesen (->Ly.GetVar(Nummer)),
    #   - von Hardware/Treiber lesen (->selber machen) oder
    # - Daten verarbeiten,
    # - Daten ausgeben
    #   - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release),
    #   - in Variablen schreiben (->Ly.SetVar(Nummer, Wert))
    #   - auf Hardware/Treiber schreiben (->selber machen)
    # - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)    
    def ProcessData(self):
        for inkanal in range(self.NumInChannel):
            if self.GetInputBlock(inkanal) is None:
                return True
        for outkanal in range(self.NumOutChannel):
            if self.GetOutputBlock(inkanal) is None:
                return True

        # Eingang  Ausgang  Kanal-Offset
        #-------------------------------------------------------------------------------------------
        #         - 0       0
        #       / 
        #   0 --  - 1       1
        #       \
        #         - 2       2
        #-------------------------------------------------------------------------------------------
        #         - 3       0
        #       /                   Ausgangsnummer = Eingangsnummer * AUSGAENGE_PRO_EINGANG + Offset
        #   1 --  - 4       1                    4 =              1 *                     3 +      1
        #       \
        #         - 5       2
        #-------------------------------------------------------------------------------------------

        # alle Eingnge durchlaufen
        for aktuellerkanal in range(self.NumInChannel):            
            InBuff = self.GetInputBlock(aktuellerkanal)             
            # Die Ausgnge mit Daten versorgen                        
            for offset in range(AUSGAENGE_PRO_EINGANG):             # 0..AUSGAENGE_PRO_EINGANG-1
                for blockpos in range(InBuff.BlockSize):            # 0..BlockSize-1                    
                    OutBuff = self.GetOutputBlock(aktuellerkanal * AUSGAENGE_PRO_EINGANG + offset)                    
                    OutBuff[blockpos] = InBuff[blockpos] + offset                    
                    OutBuff.StartTime = InBuff.StartTime
                    OutBuff.BlockSize = InBuff.BlockSize
                    OutBuff.SampleDistance = InBuff.SampleDistance
                    OutBuff.Release()
                #end for
            #end for
            InBuff.Release()
        #end for
        return True
    #end ProcessData
#end class
