# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys



class info( object ):
    def __init__(self):
        #Modul
        self.modul_zeitbasisID = 2    # 2:Treiber, 1:DASYLab (historisch bedingt ist Treiber-Zeitbasis Standard)
        #Kanal
        self.kanal_variable = [n for n in range(1,17)]  # Kanal0=1, Kanal1=2,.., Kanal15=16
    #end init
#end class



class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False
    #end init        


    # beim Laden eines Skripts ins Modul
    def Create(self):
        return True


    # Hilfsmethode: beim ffnen des Moduleigenschaftsdialogs, siehe Ende von DlgInit
    # Ausgrauen/Disablen von einstellbaren Modul/Kanal-Eigenschaften (AppendInt usw)
    def DlgPropertyControl(self, dlg, props):
        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft, aktiv sonst
        for page, prop in props:
            dlg.opt.SelectPage(page)
            dlg.opt.EnableProperty(prop, state)
    #end DlgPropertyControl


      # DASYLab 12
##    # beim Doppelklick auf ein Modul
##    def DlgInit(self, dlg):
##        # Mindestens einen Kanalbutton/Stecker im Dialog
####        if (self.NumInChannel == 0) and (self.NumOutChannel == 0):      # beide 0
####            self.DlgNumChannels = 1
####        elif (self.NumInChannel == 0):                                  # In 0
####            self.DlgNumChannels = self.NumOutChannel
####        else:                                                           # Out 0
####            self.DlgNumChannels = self.NumInChannel
##        
##        self.DlgNumChannels = (self.NumOutChannel if (self.NumOutChannel > 0) else 1)        
##        self.DlgCurrChannel = 0
##        self.DlgMaxChannels = Ly.MAX_CHANNELS
##       
##        # In mv stehen die "modul values", die der Benutzer ndern knnen soll
##        mv={}
##
##        # Zeitbasis:  zeitbasis = Ly.PyGetAllTimeBase(self.info.zeitbasisID) # ...(ID=2)
##        #
##        # zeitbasis[0] -> 1                         # Index fr zeitbasis[1]
##        # - ID der zu nutzenden Zeitbasis
##        #
##        # zeitbasis[1] -> ['1', '2', '400']         # zeitbasis[1][zeitbasis[0]] -> 2
##        # - IDs in DASYLab gefundener Zeitbasen
##        #
##        # zeitbasis[2] -> ['DASYLab', 'Treiber', 'NI-DAQmx Analog-Eingang: AI Temp']
##        # - Bezeichnungen in DASYLab gefundener Zeitbasen
##        #
##        # zeitbasis[3] -> 'DASYLab\nTreiber\nNI-DAQmx Analog-Eingang: AI Temp'
##        # - Bezeichnungen der gefundenen Zeitbasen in einem String getrennt durch
##        #   Linefeeds: kann zB benutzt werden, um Python-Combobox mit Werten zu befllen
##        zeitbasis = Ly.PyGetAllTimeBase(self.info.zeitbasisID)
##        mv["Zeitbasis"] = zeitbasis[2][zeitbasis[0]]
##
##        # In cv stehen die "channel values"
##        # - Slice [:] benutzen, um eine Kopie der Liste zu erstellen.
##        #   Andernfalls auch nderung der Werte, wenn Dialog mit Abbruch verlassen wird.
##        cv={}
##        cv["Variable"] = self.info.kanal_variable[:]
##
##        # Store buffers in v  ( has to be done before building properties )
##        dlg.opt.v = [mv, cv]            
##
##        # Dialog fr Moduleigenschaften erstellen, Seite 0
##        dlg.opt.SelectPage(0)
##        dlg.opt.AppendCategory("Modul spezifische Einstellungen")
##
##        dlg.opt.AppendEnum("Zeitbasis",
##                           zeitbasis[3], # siehe Beispiel
##                           desc="Auswahl der zu verwendenden Zeitbasis.\n\nStandard: Treiber")
##        
##        # Dialog fr angebotene Kanaleigenschaften erstellen, Seite 1
##        dlg.opt.SelectPage(1)
##        dlg.opt.AppendCategory("Kanal spezifische Einstellungen")
##        dlg.opt.AppendInt("Variable",
##                          chan=0,
##                          desc="Nummer der globalen Variable, deren Inhalt ausgegeben werden soll.\n" + \
##                               "1-999: Nummer der globalen Variable")
##
##        # Festlegen, welche Meneintrge whrend der Messung deaktiviert werden sollen,
##        # sodass sie vom Benutzer nicht verstellt werden knnen.
##        # (Dialogseite, Property name)
##        DlgDeactivatableProperties = []
##        DlgDeactivatableProperties.append((0,"Zeitbasis"))
##        DlgDeactivatableProperties.append((1,"Variable"))
##        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
###end DlgInit12


    # DASYLab 13
    # beim Doppelklick auf ein Modul
    def DlgInit(self, dlg):
        # Mindestens einen Kanalbutton/Stecker im Dialog
        
        self.DlgNumChannels = (self.NumOutChannel if (self.NumOutChannel > 0) else 1)        
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS

        tb_index, tb_ids, tb_names, tb_enum = Ly.GetAllTimeBases(self.info.modul_zeitbasisID)
        timebasename = tb_names[tb_index]

##        zeitbasis = Ly.GetAllTimeBases(self.info.modul_zeitbasisID)
##        print zeitbasis

        # zeitbasis[0] -> 1                         # Index fr zeitbasis[1]
        # - ID der zu nutzenden Zeitbasis
        #
        # zeitbasis[1] -> ['1', '2', '400']         # zeitbasis[1][zeitbasis[0]] -> 2
        # - IDs in DASYLab gefundener Zeitbasen
        #
        # zeitbasis[2] -> ['DASYLab', 'Treiber', 'NI-DAQmx Analog-Eingang: AI Temp']
        # - Bezeichnungen in DASYLab gefundener Zeitbasen
        #
        # zeitbasis[3] -> 'DASYLab\nTreiber\nNI-DAQmx Analog-Eingang: AI Temp'
        # - Bezeichnungen der gefundenen Zeitbasen in einem String getrennt durch
        #   Linefeeds: kann zB benutzt werden, um Python-Combobox mit Werten zu befllen        

        dlg.title = "Variable lesen"

        dim = lys.DialogManager(self, dlg)

        #Modulseite
        dim.SelectModulePage()
        dim.AppendCategory("Modul spezifische Einstellungen", "Modul spezifische Einstellungen")
        dim.AppendEnum("Zeitbasis", tb_enum, timebasename, "Wahl der Zeitbasis")
        #Kanalseite
        dim.SelectChannelPage()
        dim.AppendCategory("Modul spezifische Einstellungen", "Modul spezifische Einstellungen")
        dim.AppendInt("Variable",
                      self.info.kanal_variable,
                      desc="Nummer der globalen Variable, deren Inhalt ausgegeben werden soll.\n" + \
                               "1-999: Nummer der globalen Variable")     

        # Festlegen, welche Meneintrge whrend der Messung deaktiviert werden sollen,
        # sodass sie vom Benutzer nicht verstellt werden knnen.
        # (Dialogseite, Property name)
        DlgDeactivatableProperties = []
        DlgDeactivatableProperties.append((0,"Zeitbasis"))
        DlgDeactivatableProperties.append((1,"Variable"))
        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
#end DlgInit12
           

#DASYLab 12
##    # Dialog wird mit Ok-Taste verlassen
##    # - Im Dialog vernderte Werte mssen nun noch ins info-Objekt gespeichert werden,
##    #   damit DASYLab sie auch fr die Messung verwendet. Bisher stehen die Werte nur
##    #   "im" Dialog.
##    # - Prfen, ob die eingestellten Werte auch einen Sinn ergeben.
##    #   zB: Eine globale Variable mit Nummer ber 999 gibt es nicht.
##    def DlgOk(self, dlg):
##        
##        def varInRange1To999(v):
##            return (True if ((v >= 1) and (v <= 999)) else False)
##        
##        mv = dlg.opt.v[0]   # aktuell im Dialog eingestellte, aber noch nicht gespeicherte Eigenschaften
##        cv = dlg.opt.v[1]   #    mv: Moduleinstellungen, Seite 0
##                            #    cv: Kanaleinstellungen, Seite 1
##                            
##        # Speichern der allgemeinen Moduleigenschaften:
##        self.info.zeitbasisID = Ly.PyGetTimeBaseIDForATimeBaseName(mv["Zeitbasis"])
##        # Speichern der Kanaleinstellungen
##        # - jede eingegebene Nummer kanalweise prfen
##        for kanal in range(self.NumOutChannel):
##            varnum = cv["Variable"][kanal]
##            if varInRange1To999(varnum):
##                self.info.kanal_variable[kanal] = varnum
##            else:
##                print "Der in Kanal "+str(kanal)+" eingestellte Wert '"+str(varnum) + \
##                      "' ist keine zulssige Nummer fr eine globale Variable!\n" + \
##                      "Gltige Werte: [1..999]"
##    #end DlgOk12


#DASYLab 13
    # Dialog wird mit Ok-Taste verlassen
    # - Im Dialog vernderte Werte mssen nun noch ins info-Objekt gespeichert werden,
    #   damit DASYLab sie auch fr die Messung verwendet. Bisher stehen die Werte nur
    #   "im" Dialog.
    # - Prfen, ob die eingestellten Werte auch einen Sinn ergeben.
    #   zB: Eine globale Variable mit Nummer ber 999 gibt es nicht.
    def DlgOk(self, dlg):

        # Hilfsfunktion        
        def varInRange1To999(v):
            return (True if ((v >= 1) and (v <= 999)) else False)

        dom = lys.DialogOkManager(dlg)
        
        #Modulseite
        dom.SelectModulePage()
        self.info.zeitbasisID = Ly.GetTimeBaseIDByName( dom.GetValue("Zeitbasis") )

        #Kanalseite
        dom.SelectChannelPage()
        tmplist = dom.GetValue("Variable") # liefert eine Liste(Kanalseite!) der gerade im Dialog eingestellten Werte

        # Jede eingegebene Nummer kanalweise prfen, ob sie als Variablennummer taugt.
        for kanal in range(self.NumOutChannel):
            num = tmplist[kanal]
            if varInRange1To999(num):
                self.info.kanal_variable[kanal] = num
            else:
                print "Der in Kanal "+str(kanal)+" eingestellte Wert '"+str(num) + \
                      "' ist kein zulssiger Wert fr eine globale Variable!\n" + \
                      "Gltige Werte: [1..999]"
            #end if
        #end for
                
    #end DlgOk13


    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.
    def DlgCancel(self, dlg):
        pass

        
    # Schaltbild wird gespeichert.
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe-FIFOs
    def SetupFifo(self, channel):
        self.SetSampleDistance(channel, Ly.GetTimeBaseSampleDistance(self.info.zeitbasisID))
        self.SetMaxBlockSize(channel, Ly.GetTimeBaseBlockSize(self.info.zeitbasisID))
    #end SetupFifo


    # Die Messung wird gestartet.
    def Start(self):
        self.sampledistance = Ly.GetTimeBaseSampleDistance(self.info.zeitbasisID)
        self.blocksize = Ly.GetTimeBaseBlockSize(self.info.zeitbasisID)        
        self.time = 0.0
        self.blockcount = 0    
        self.MeasurementRunning = True
    #end Start


    # Die Messung wird gestoppt.        
    def Stop(self):
        self.MeasurementRunning = False
    

    # Wenn dieses Modul an der Reihe ist, i.d.R.:
    # - Daten beschaffen
    #   - Datenblcke an den Eingngen abholen (->InBuff[..]),
    #   - aus Variablen lesen (->Ly.GetVar(Nummer)) oder
    #   - von Hardware/Treiber lesen (->selber machen) 
    # - Daten verarbeiten,
    # - Daten ausgeben
    #   - auf Modulausgnge geben (->OutBuff[..]) und freigeben (OutBuff.Release),
    #   - in Variablen schreiben (->Ly.SetVar(Nummer, Wert)) oder
    #   - auf Hardware/Treiber schreiben (->selber machen)
    # - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)
    def ProcessData(self):
        # Da hier immer ganze Blcke vollgeschrieben werden, braucht man nur prfen,
        # ob die Zeit gekommen ist, mit der Verarbeitung eines neuen Blocks zu beginnen.
        now = Ly.GetTimeBaseTime(self.info.zeitbasisID)
        if (now < self.time):
            return

        # Daten jedes Kanals separat verarbeiten
        for aktuellerkanal in range(self.NumOutChannel):
            OutBuff = self.GetOutputBlock(aktuellerkanal)
            OutBuff.StartTime = self.time
            OutBuff.SampleDistance = self.sampledistance
            OutBuff.BlockSize = self.blocksize
            
            # Wert aus globaler Variable lesen
            num = self.info.kanal_variable[aktuellerkanal]
            data = Ly.GetVar(num)

            # Einen kompletten Block eines Kanals mit dem Wert vollschreiben
            for blockpos in range(OutBuff.BlockSize):      # range: 0..blocksize-1
                OutBuff[blockpos] = data

            # Den vollgeschriebenen Block des aktuellen Kanals freigeben
            OutBuff.Release()
        #end for

        # Ein Block wurde gefllt, Anzahl erhhen
        self.blockcount += 1
        
        # Beispiel zur Zeitberechnung:
        #
        # - Abtastrate 10 Hz   ->   Sampledistanz=1/10 = 0.1 [s]
        # - Blockgre 5
        #
        #    --------- 1. Block    --------- 3. Block
        #    - Sample
        #  ##0|1|2|3|4##0|1|2|3|4##0|1|2|3|4##...
        #    - time=0                           blockcount * SampleDistance * blocksize [s]
        #               - time=0.5              1          * 0.1            * 5
        #                          - time=1     2          * 0.1            * 5
        self.time = self.blockcount * OutBuff.SampleDistance * OutBuff.BlockSize
        
        return True
    #end processdata
#end class


    

## ZWISCHENABLAGE ##

## readtime = self.time \
##            + Ly.GetTimeBaseSampleDistance(self.info.zeitbasisID) \
##            * self.blockpos


# Einen kompletten Block mit dem Wert vollschreiben
##            self.blockpos = 0
##            while (self.blockpos <= OutBuff.BlockSize-1):
##                OutBuff[self.blockpos] = data
##                self.blockpos += 1


##  print Ly.__dict__
##{'M_1_SQRTPI': 0.56418958354775628,
## 'SetTimeBase': <built-in function SetTimeBase>,
## 'M_LOG10E': 0.43429448190325182,
## 'GetTimeBaseBlockSize': <built-in function GetTimeBaseBlockSize>,
## 'CF_NORMAL': 0,
## 'CR_1_ALL': 4,
## 'Buffer': <type 'Ly.Buffer'>,
## 'CSPD_CT_SPEC2': 2,
## 'CR_BBOXSAT': 10,
## 'CR_BBOXIO': 9,
## 'CSPD_CT_SPEC4': 4,
## 'SetVar': <built-in function SetVar>,
## 'CT_OCT': 15,
## 'CSPD_CT_NORMAL': 0,
## 'M_LN2': 0.69314718055994529,
## 'CR_1_2': 2,
## 'OutStd': <built-in function OutStd>,
## 'M_PI': 3.1415926535897931,
## 'Optpage': <type 'Ly.Optpage'>,
## 'M_PI_2': 1.5707963267948966,
## 'M_PI_4': 0.78539816339744828,
## 'M_TWO_PI': 6.2831853071795862,
## 'DataBlockHeader': <type 'Ly.DataBlockHeader'>,
## 'M_E': 2.7182818284590451,
## 'M_1K5_PI': 4.7123889803846897,
## 'UnregisterTimeBase': <built-in function UnregisterTimeBase>,
## 'GetTimeBaseComboID': <built-in function GetTimeBaseComboID>,
## '__name__': 'Ly',
## 'OptDlg': <type 'Ly.OptDlg'>,
## 'CR_2_1_FIRST': 11,
## 'PyGetAllTimeBase': <built-in function PyGetAllTimeBase>,
## 'M_ZWEI_PI': 6.2831853071795862,
## 'M_LN10': 2.3025850929940459,
## 'CF_SHORT_BLK': 2,
## 'CF_DELAY': 8192,
## 'QueryPerformanceCounter': <built-in function QueryPerformanceCounter>,
## 'Outf': <built-in function Outf>,
## 'GetStr': <built-in function GetStr>,
## 'CT_NORMAL': 0, 'CR_2_2': 3,
## 'M_LOG2E': 1.4426950408889634,
## 'M_SQRT_2': 0.70710678118654757, 'CR_2_1': 1,
## 'M_2_SQRTPI': 1.1283791670955126,
## '__doc__': None,
## 'CSPD_CT_SPEC': 1,
## 'CF_COPY_PART': 4095,
## 'CF_ASYNC': 2,
## 'OutErr': <built-in function OutErr>,
## 'CF_READY': 4096,
## 'testval': <built-in function testval>,
## 'MAX_CHANNELS': 16,
## 'CT_SPEC3': 12,
## 'PyGetTimeBaseIDForATimeBaseName': <built-in function PyGetTimeBaseIDForATimeBaseName>,
## 'CT_BINARY': 1, 'CR_DELAY': 7,
## 'SetTimeBaseTime': <built-in function SetTimeBaseTime>,
## 'GetTimeBaseSampleDistance': <built-in function GetTimeBaseSampleDistance>,
## 'CR_BBOX': 8,
## 'HwDlg': <type 'Ly.HwDlg'>,
## 'M_1_PI': 0.31830988618379069,
## 'CF_HOLES': 1,
## 'CT_CLASS2': 21,
## 'CR_ALL_1': 5,
## 'M_2_PI': 0.63661977236758138,
## '__package__': None,
## 'SetStr': <built-in function SetStr>,
## 'test': <built-in function test>,
## 'CT_SPEC2': 11,
## 'CSPD_CT_CLASS2': 8,
## 'GetTimeBaseTime': <built-in function GetTimeBaseTime>,
## 'CT_SPEC4': 13,
## 'IncTimeBaseTime': <built-in function IncTimeBaseTime>,
## 'QueryPerformanceFrequency': <built-in function QueryPerformanceFrequency>,
## 'CT_SPEC': 10,
## 'CT_TERZ': 14,
## 'StopExperiment': <built-in function StopExperiment>,
## 'CR_ALL_ALL': 13,
## 'GetVar': <built-in function GetVar>,
## 'CR_NORMAL': 0,
## 'Mclass': <type 'Ly.Mclass'>,
## 'CT_CLASS': 20,
## 'UdButtons': <type 'Ly.UdButtons'>,
## 'PyRegisterTimeBase': <built-in function PyRegisterTimeBase>,
## 'M_SQRT2': 1.4142135623730951,
## 'CR_NONE': 12,
## 'CR_1_LESS': 6,
## 'CT_DIG_WORD': 30}

            
    
