# -*- coding: iso-8859-15 -*-

import Ly
import lys
import sys



class info( object ):
    def __init__( self ):
        # Modul
        # - In diesem Modul nicht verwendet.
        # Kanal
        # - Fr jeden der 16 Kanle den Wert vorbelegen.
        self.kanal_variable = [n for n in range(1,17)]  # Kanal0=1, Kanal1=2,.., Kanal15=16
    #end def
#end class



class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False
    #end init


    # beim Laden eines Skripts ins Modul
    def Create(self):
        return True


    # Hilfsmethode: beim ffnen des Moduleigenschaftsdialogs, siehe Ende von DlgInit
    # Ausgrauen/Disablen von einstellbaren Modul/Kanal-Eigenschaften (AppendInt usw)
    def DlgPropertyControl(self, dlg, props):
        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft, aktiv sonst
        for page, prop in props:
            dlg.opt.SelectPage(page)
            dlg.opt.EnableProperty(prop, state)
    #end DlgPropertyControl


    # beim Doppelklick auf ein Modul
    def DlgInit(self, dlg):
        # Mindestens einen Kanalbutton/Stecker im Dialog
        self.DlgNumChannels = (self.NumInChannel if (self.NumInChannel > 0) else 1)        
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS

        dim = lys.DialogManager(self, dlg)
        dim.SelectModulePage()
        dim.AppendCategory("Modul-Einstellungen: keine!", "") # keine Beschreibung

        dim.SelectChannelPage()
        dim.AppendCategory("Kanal spezifische Einstellungen", "")
        dim.AppendInt( "Variable",
                       self.info.kanal_variable,
                       desc="Nummer der globalen Variable, in die empfangene Daten geschrieben werden." \
                       +"\n1-999: Nummer der globalen Variable" \
                       +"\n0: Schreibe empfangenen Wert NICHT in Variable.")

        # Festlegen, welche Meneintrge whrend der Messung deaktiviert werden sollen,
        # sodass sie vom Benutzer nicht mehr verstellt werden knnen.
        # (Dialogseite, Property name)
        DlgDeactivatableProperties = []
        DlgDeactivatableProperties.append((1,"Variable"))
        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
    #end DlgInit
            

    # Dialog wird mit Ok-Taste verlassen
    # - Im Dialog vernderte Werte mssen nun noch ins info-Objekt gespeichert werden,
    #   damit DASYLab sie auch fr die Messung verwendet. Bisher stehen die Werte nur
    #   "im" Dialog.
    # - Prfen, ob die eingestellten werde auch einen Sinn ergeben.
    #   zB: Eine globale Variable mit Nummer ber 999 gibt es nicht.
    # - Sonstiges mit den eingestellten Werten anfangen:
    #   zB: Eingabe von 0 fhrt dazu, dass der empfangene Wert in
    #   keine globale Variable geschrieben wird. Siehe ProcessData.
    def DlgOk(self, dlg):
        
        def varInRange0To999(v):
            return (True if ((v >= 0) and (v <= 999)) else False)

        dom = lys.DialogOkManager(dlg)

        #Modulseite
        dom.SelectModulePage()
        #nichts

        #Kanalseite
        dom.SelectChannelPage()        
        tmplist = dom.GetValue("Variable")

        # Jede eingegebene Nummer kanalweise prfen, ob sie als Variablennummer taugt.
        for channel in range(self.NumInChannel):
            num = tmplist[channel]
            if varInRange0To999( num ):
                self.info.kanal_variable[channel] = num
            #end if
        #end for
    #end DlgOk       
            

    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.
    def DlgCancel(self, dlg):
        pass

        
    # Schaltbild wird gespeichert.
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe-FIFOs
    # - zB mit welcher Blockgre gibt das Modul Daten aus.
    def SetupFifo(self, channel):
        pass


    # Die Messung wird gestartet.
    def Start(self):
        self.MeasurementRunning = True


    # Die Messung wird gestoppt.        
    def Stop(self):
        self.MeasurementRunning = False
    

    # Wenn dieses Modul an der Reihe ist.
    # i.d.R.: - Daten beschaffen
    #           - Datenblcke an den Eingngen abholen (->InBuff),
    #           - aus Variablen lesen (->Ly.GetVar(Nummer)),
    #           - von Hardware/Treiber lesen (->selber machen) oder
    #         - Daten verarbeiten,
    #         - Daten ausgeben
    #           - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release),
    #           - in Variablen schreiben (->Ly.SetVar(Nummer, Wert))
    #           - auf Hardware/Treiber schreiben (->selber machen)
    #         - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)
    def ProcessData(self):
        
        # Liegen an allen Eingngen Daten vor?
        for aktuellerkanal in range(self.NumInChannel):
            if self.GetInputBlock(aktuellerkanal) is None:
                return True
            
        # Das vorgelagerte Modul hat seine(n) OutBuff(s) freigegeben und
        # an allen Eingngen dieses Moduls liegen Daten zur Verarbeitung bereit.
        for aktuellerkanal in range(self.NumInChannel):
            
            InBuff = self.GetInputBlock(aktuellerkanal) # InBuff hat die Daten des Kanals 'channel'

            var = self.info.kanal_variable[aktuellerkanal]
            if (var > 0):                                   # 0: Wert nicht in globVar schreiben.
                data = InBuff[InBuff.BlockSize-1]           # zB Blocksize=1 --> Index 0
                Ly.SetVar(var, data)                        # schreibt Inhalt von data in glob. Variable var
                        
            InBuff.Release()
        return True
#end class
            
    
