# -*- coding: iso-8859-15 -*-


import Ly
import lys
import sys

class info(object):
    def __init__(self):
        # Variables for settings
        # Example variables
        self.m_timebase_id = 1

class pvar(object):
    def __init__(self):
        # Working variables
        # Example variables
        self.m_outputs_done = 0
        self.m_m = 0.0
        self.c_n = [1.0 for n in range(16)] 
        
        import math       
        self.math = math

class pscript(lys.mclass):
    def __init__(self, magic):
        self.info=info()
        self.pvar=pvar()

    def Create (self):
        # Module initialization
        return True

    def Delete (self):
        # Tidy up on deletion of the module (if needed)
        pass

    def DlgInit (self, dlg):
        # Initialization of settings dialog
        
        # Set dialog title
        dlg.title = "Script (Input Data)"
        # Determine the number of channels, current channel and
        # maximum number of channels
        # (Covers moduls which have only outputs and at least one of them. 
        # You need to adjust this section if you have chosen another relation 
        # setting. You can find more information how to do this in the help)
        self.DlgNumChannels = self.NumOutChannel
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS
        # Setup dialog parameters

        tb_index, tb_ids, tb_names, tb_enum = Ly.GetAllTimeBases(self.info.m_timebase_id)
        timebasename = tb_names[tb_index]

        dim = lys.DialogManager(self, dlg)
        dim.SelectModulePage()
        dim.AppendEnum("Timebase", tb_enum, timebasename, "Choose Timebase")
        dim.SelectChannelPage()

    def DlgOk (self, dlg):
        # (oo)
        # Get values of dialog parameters
        # Click on the help button to get more information.
        dom = lys.DialogOkManager(dlg)
        dom.SelectModulePage()
        tb_index, tb_ids, tb_names, tb_enum = Ly.GetAllTimeBases(self.info.m_timebase_id)
        timebasename = dom.GetValue("Timebase")
        for n in range(len(tb_names)):
            if (tb_names[n] == timebasename):
                self.info.m_timebase_id = int(tb_ids[n])
                break
        dom.SelectChannelPage()
        
        # Configure Inputs and Outputs
        # (Covers moduls which have only outputs and at least one of them. 
        # You need to adjust this section if you have chosen another relation 
        # setting. You can find more information how to do this in the help)
        self.SetConnectors(0, self.DlgNumChannels) 

    def DlgCancel (self, dlg):
        # (oo)
        # Cancel button clicked. 
        # Click on the help button to get more information.
        pass

    def Save (self):
        # (oo)
        # Prepare data before worksheet will be saved (if needed)
        # Click on the help button to get more information.
        pass

    def Load (self):
        # (oo)
        # Prepare data after worksheet has been loaded (if needed)
        # Click on the help button to get more information.
        pass

    def Start (self):
        # (oo)
        # Initialize variables on start of measurement (if needed)
        # Click on the help button to get more information.
        self.pvar.m_outputs_done = 0

    def Stop (self):
        # (oo)
        # Tidy up on stop of measurement (if needed)
        # Click on the help button to get more information.
        pass

    def SetupFifo (self, channel):
        # (oo)
        # Setup flags, types and max. block size of a channel (if needed)
        # Click on the help button to get more information.
        self.SetSampleDistance(channel, Ly.GetTimeBaseSampleDistance(self.info.m_timebase_id))
        self.SetMaxBlockSize(channel, Ly.GetTimeBaseBlockSize(self.info.m_timebase_id))
        self.SetChannelType(channel, Ly.CT_NORMAL)
        self.SetChannelFlags(channel, Ly.CF_NORMAL)
        

    def ProcessValue (self, v, c):
        # (oo)
        # Process single value
        # Click on the help button to get more information.
        block_time, sample_index, sample_distance = v
        return self.pvar.math.sin(block_time + sample_index * sample_distance)

    def ProcessData (self):
        # (oo)
        # Process data blocks
        # Click on the help button to get more information.
        
        # Process the channels
        bsize = Ly.GetTimeBaseBlockSize(self.info.m_timebase_id)
        sdist = Ly.GetTimeBaseSampleDistance(self.info.m_timebase_id)
        btime = bsize * sdist
        this_time = Ly.GetTimeBaseTime(self.info.m_timebase_id)
        next_time = self.pvar.m_outputs_done * btime
        if (this_time >= next_time):
            for channel in xrange(self.NumOutChannel):
                OutBuff = self.GetOutputBlock(channel)
                for i in xrange(bsize):
                    OutBuff[i] = self.ProcessValue((next_time, i, sdist), channel)
                OutBuff.StartTime = next_time
                OutBuff.SampleDistance = sdist
                OutBuff.BlockSize = bsize
                OutBuff.Release()
            self.pvar.m_outputs_done += 1
                
        return True 
