# -*- coding: iso-8859-15 -*-

import Ly
import sys

# exemplarisch fr Kleinbuchstaben
# genutzte ASCII-Tabelle: http://www.torsten-horn.de/techdocs/ascii.htm
HEX_TABELLE = {'a': '61', 'b': '62', 'c': '63', 'd': '64', 'e': '65', 'f': '66',
               'g': '67', 'h': '68', 'i': '69', 'j': '6A', 'k': '6B', 'l': '6C',
               'm': '6D', 'n': '6E', 'o': '6F', 'p': '70', 'q': '71', 'r': '72',
               's': '73', 't': '74', 'u': '75', 'v': '76', 'w': '77', 'x': '78',
               'y': '79', 'z': '7A'}


class info( object ):
    # Das info-Objekt speichert die Einstellungen, die man im Dialog ndern kann.
    def __init__( self ):
        # Modul
        # - In diesem Modul nicht verwendet, sonst zB  self.modul_zeitbasis = "Treiber" o..
        # Kanal
        # - Fr jeden der 16 Kanle den Wert vorbelegen.
        self.kanal_stringnummer_quelle = [n for n in range(1,17)]  # Kanal0=1, Kanal1=2,.., Kanal15=16
        self.kanal_stringnummer_ziel = [n+1 for n in range(1,17)]  # Kanal0=2, Kanal1=3,.., Kanal15=17


class pscript(Ly.Mclass):

    # beim Laden eines Schaltbilds und beim Laden einen Skripts ins Modul
    def __init__(self, magic):
        self.info = info()
        self.MeasurementRunning = False


    # beim Laden eines Skripts ins Modul
    # festlegen, wie viele Ein-/Ausgnge das Modul direkt nach dem Reinziehen
    # ins Schaltbild haben soll. Die Kanalrelation bestimmt, wie viele
    # Eingnge Ausgngen zugeordnet sein sollen (siehe zB Arithmetik: Eingang 1+2=Ausgang1)
    def Create(self):
        self.NumInChannel = 1
        self.NumOutChannel = 0
        self.ChannelRelation = Ly.CR_NORMAL
        return True


    # Hilfsmethode: ausgrauen von Einstellungen beim ffnen des Dialogs,
    #  falls Messung luft, sonst nicht
    def DlgPropertyControl(self, dlg, props):
        state = (not self.MeasurementRunning) # deaktivieren/False, wenn Messung luft, aktiv sonst
        for page, prop in props:
            dlg.opt.SelectPage(page)
            dlg.opt.EnableProperty(prop, state)


    # beim Doppelklick auf's Modul: Dialog-Optionen zusammenstellen
    def DlgInit(self, dlg):
        # Mindestens einen Kanalbutton/Stecker im Dialog
        self.DlgNumChannels = (1 if self.NumInChannel < 1 else self.NumInChannel)
        self.DlgCurrChannel = 0
        self.DlgMaxChannels = Ly.MAX_CHANNELS

        dm = lys.DialogManager(self, dlg)
       
        # "modul values"
        dm.SelectModulePage()
        dm.AppendCategory("Modul-Einstellungen: keine!", "")
        # - In diesem Modul nicht verwendet.


        dm.SelectChannelPage()
        dm.AppendCategory("Kanal spezifische Einstellungen", "")

        dm.AppendInt("Stringnummer Quelle",
                     self.info.kanal_stringnummer_quelle,
                     desc="Nummer des globalen Strings, dessen Inhalt umgewandelt werden soll." \
                     +"\n1-999: Nummer der globalen Variable" )
        dm.AppendInt("Stringnummer Ziel",
                     self.info.kanal_stringnummer_ziel,
                     desc="Nummer des globalen Strings, der den umgewandelten Inhalt aufnimmt." \
                     +"\n1-999: Nummer der globalen Variable")        

        # Festlegen, welche Meneintrge whrend der Messung deaktiviert werden sollen,
        # sodass sie vom Benutzer nicht mehr verstellt werden knnen.
        # (Dialogseite, Property name)
        DlgDeactivatableProperties = []
        DlgDeactivatableProperties.append((1,"Stringnummer Quelle"))
        DlgDeactivatableProperties.append((1,"Stringnummer Ziel"))
        self.DlgPropertyControl(dlg, DlgDeactivatableProperties)
    #end DlgInit
            

    # Dialog wird mit Ok-Taste verlassen
    # - Im Dialog vernderte Werte mssen nun noch ins info-Objekt gespeichert werden,
    #   damit DASYLab sie auch fr die Messung verwendet. Bisher stehen die Werte nur
    #   "im" Dialog.
    # - Prfen, ob die eingestellten werde auch einen Sinn ergeben.
    #   zB: Eine globale Variable mit Nummer ber 999 gibt es nicht.
    # - Sonstiges mit den eingestellten Werten anfangen:
    #   zB: Eingabe von 0 fhrt dazu, dass der empfangene Wert in
    #   keine globale Variable geschrieben wird. Siehe ProcessData.
    def DlgOk(self, dlg):
        
        def varInRange1To999(v):
            return (True if ((v >= 1) and (v <= 999)) else False)

        dom = lys.DialogOkManager(dlg)

        #Modul
        dom.SelectModulePage()
        #nichts

        #Kanle
        dom.SelectChannelPage()
        for channel in range(self.NumInChannel):
            if varInRange1To999(dom.GetValue("Stringnummer Quelle")[channel]) and \
               varInRange1To999(dom.GetValue("Stringnummer Ziel")[channel]):
                self.info.kanal_stringnummer_quelle[channel] = dom.GetValue("Stringnummer Quelle")[channel]
                self.info.kanal_stringnummer_ziel[channel] = dom.GetValue("Stringnummer Ziel")[channel]
            else:
                pass # nichts tun, falls eine Stringnummer kleiner 1 oder grer 999 eingegeben wurde.
    #end DlgOk
            

    # Dialog wird mit Abbrechen-Taste verlassen. Nichts zu tun.
    # Vernderte Einstellungen waren nur "im" Dialog gettigt.
    # Das info-Objekt hlt noch die unvernderten Werte.
    def DlgCancel(self, dlg):
        pass

        
    # Schaltbild wird gespeichert.
    def Save(self):
        pass


    # Schaltbild wird geladen.
    def Load(self):
        pass


    # Konfiguration der Ausgabe-FIFOs
    # - zB mit welcher Blockgre gibt das Modul Daten aus.
    # hier: Kein Ausgang vorhanden, also auch keine Konfiguration ntig.
    def SetupFifo(self, channel):
        pass


    # Die Messung wird gestartet.
    def Start(self):
        self.MeasurementRunning = True


    # Die Messung wird gestoppt.        
    def Stop(self):
        self.MeasurementRunning = False
    
    
    # Wenn dieses Modul an der Reihe ist, durch DASYLab bearbeitet zu werden,
    # i.d.R.: - Daten beschaffen (Beispiele)
    #           - Datenblcke an den Eingngen abholen (->InBuff) und/oder
    #           - aus Variablen lesen (->Ly.GetVar(Nummer)) und/oder
    #           - von Hardware/Treiber lesen (->selber machen) 
    #         - Daten verarbeiten,
    #         - Daten ausgeben (Beispiele)
    #           - auf Modulausgnge geben (->OutBuff) und freigeben (OutBuff.Release) und/oder
    #           - in Variablen schreiben (->Ly.SetVar(Nummer, Wert)) und/oder
    #           - auf Hardware/Treiber schreiben (->selber machen) und/oder
    #         - "Eingabeschleuse rumen, Programm." (Tron, 1982) (InBuff.Release)
    def ProcessData(self):
        
        # Liegen an allen Eingngen Daten vor?
        # Vorsicht: Synchronizitt der Blcke ungeprft! Es knnen hier auch Blcke
        # mit unterschiedlichen Zeitstempeln verarbeitet werden (siehe: Linienschreiber).
        for aktuellerkanal in range(self.NumInChannel):
            if self.GetInputBlock(aktuellerkanal) is None:
                return True
            
        # Ab hier:
        # Das vorgelagerte Modul hat seine(n) OutBuff(s) freigegeben und
        # an ALLEN Eingngen dieses Moduls liegen Daten zur Verarbeitung bereit.
        # Jetzt fr jeden Eingang die Daten irgendwie verarbeiten.
        #
        # Da der Inhalt der eintreffenden Blcke egal ist, nutzen wir die ankommenden Blcke
        # des Handreglers nur als "Takt", um die Quell-Strings anzugucken und umzuwandeln:
        # 1000x pro Sekunde muss man dies nicht machen, also die DASYLab-Zeitbasis mit Standard-
        # Einstellungen nutzen: 10 Hz, Blockgre 1 -> String wird 10 pro Sekunde gewandelt.
        # Soll's langsamer laufen: Blockgre rauf oder Datenfenster-Modul hinter Handregler
        # einfgen und Blcke sammeln.
        for aktuellerkanal in range(self.NumInChannel):
            InBuff = self.GetInputBlock(aktuellerkanal) # Block des aktuellen Kanals/Eingangs holen

            # Welche Stringnummern beherbergen den Quell- und Zielstring? Steht im info-Objekt!
            stringnummer_quelle = self.info.kanal_stringnummer_quelle[aktuellerkanal]
            stringnummer_ziel = self.info.kanal_stringnummer_ziel[aktuellerkanal]

            # Quell-String lesen mit Bibliotheks-Funktion Ly.GetStr(<int_1..999>)
            string_quelle = Ly.GetStr(stringnummer_quelle)
            string_ziel = ""

            # Umwandlung per Tabellen-Lookup
            for zeichen in string_quelle:
                hex_zeichen = (HEX_TABELLE[zeichen] if (zeichen in HEX_TABELLE) else zeichen)
                string_ziel = string_ziel + hex_zeichen

            # Vernderten String in Ziel-String schreiben
            Ly.SetStr(stringnummer_ziel, string_ziel)
                        
            InBuff.Release() #
        return True
#end class
            
    
